# 
# Subclass of Template::Stash to track undefined variables
#

package Template::SmudgeStash;

use Template::Stash;

use vars qw(@ISA);
@ISA = qw(Template::Stash);

my @IGNORE = qw(component);

sub new
{
  my $this = shift;
  my $class = ref $this || $this; 
  my $self = $this->SUPER::new(@_);
  bless $self, $this;
  $self->{_smudge} = {};
  $self
}

sub undefined { undef };

#
# Subclass get to record variables without a value
#
sub get 
{
  my $self = shift;
  my ($var) = @_;
  my $value = $self->SUPER::get(@_);
  return $value if grep /^$var$/, @IGNORE;
  $self->{_smudge}->{$var} = 1 if ! defined $value;
  return $value;
}

#
# Return a hashref of the empty variables we've seen
#
sub unsmudged
{
  my $self = shift;
  return $self->{_smudge};
}

1;

# arch-tag: 4f81f571-9127-405f-802e-3fb675650b55
# vim:sw=2

